#include <X11/imlib.h>
#include <X11/fontlib.h>

Display *disp;
Window win;
ImlibData *imd;
FontlibData *fnd;

int 
main (int argc, char **argv)
{
   int i;
   Image *im;
   char s[2048],ident[1024];
   int r,g,b;
   int bl,br,bt,bb;
   ImColor icl;
   int first;
   
   if (argc<3)
     {
	printf("Usage:\n");
	printf("\t%s outfile.eim [options] infile1 [options] [infile2] ...\n",argv[0]);
	printf("where options can be:\n");
	printf("\t-shape R G B (R, G and B =red, green and blue value (0-255)\n");
	printf("\t-border L R T B ( L, R, T and B are left, right, top and bottom borders in pixels\n");
	printf("\t-ident identification_string (string to identify image within file)\n");
	exit(0);
     }
   disp=XOpenDisplay(NULL);
   imd=ImlibInit(disp);
   fnd=FontlibInit(imd);
   
   i=2;
   r=-1;g=-1;b=-1;
   bl=0;br=0;bt=0;bb=0;
   first=1;
   ident[0]=0;
   while (i<argc)
     {
	if (!strcmp(argv[i],"-shape"))
	  {
	     r=atoi(argv[++i]);
	     g=atoi(argv[++i]);
	     b=atoi(argv[++i]);
	  }
	else if (!strcmp(argv[i],"-border"))
	  {
	     bl=atoi(argv[++i]);
	     br=atoi(argv[++i]);
	     bt=atoi(argv[++i]);
	     bb=atoi(argv[++i]);
	  }
	else if (!strcmp(argv[i],"-ident"))
	  {
	     strcpy(ident,argv[++i]);
	  }
	else
	  {
	     im=ImlibLoadImage(imd,argv[i],NULL);
	     if (im)
	       {
		  icl.r=r;icl.g=g;icl.b=b;
		  
		  ImlibSetImageTransparentColor(imd,im,&icl);
		  ImlibSetImageBorder(imd,im,bl,br,bt,bb);
		  if (ident[0]) sprintf(s,"%s:%s",argv[1],ident);
		  else strcpy(s,argv[1]);
		  if (first)
		    {
		       ImlibSaveImageToEIM(imd,im,s);
		       first=0;
		    }
		  else
		    ImlibAddImageToEIM(imd,im,s);
	       }
	     r=g=b=-1;
	     bl=br=bt=bb=0;
	     ident[0]=0;
	  }
	i++;
     }
}

