#include <X11/imlib.h>
#include <X11/fontlib.h>
#include <X11/extensions/shape.h>
Display *disp;
Window win;
ImlibData *imd;
FontlibData *fnd;

Style *setstyle()
{
   Style *s;
   int outline,bevel,shadow,grads;
   ImColor icl_txt,icl_out,icl_shad,icl_hi,icl_low,icl_hihi,icl_lowlow;

   outline=1;
   bevel=1;
   shadow=1;
   grads=24;
   icl_txt.r=17;    icl_txt.g=32;    icl_txt.b=37;
   icl_out.r=0;     icl_out.g=0;     icl_out.b=00;
   icl_shad.r=0;    icl_shad.g=14;   icl_shad.b=18;
   icl_hi.r=255 ;   icl_hi.g=255;    icl_hi.b=200;
   icl_low.r=0;     icl_low.g=18;    icl_low.b=22;
   icl_hihi.r=255;  icl_hihi.g=255;  icl_hihi.b=255;
   icl_lowlow.r=33; icl_lowlow.g=242;icl_lowlow.b=255;
   s=FontlibInitStyle(fnd,&icl_txt,&icl_out,&icl_shad,&icl_hi,&icl_low,
		      &icl_hihi,&icl_lowlow,outline,shadow,bevel,grads);
   return s;
}

int 
main (int argc, char **argv)
{
   int i;
   char s[1024];
   Image *im1,*im2,*im3;
   XEvent ev;
   Pixmap pmap1, pmap2, pmap3;
   Pixmap mask1, mask2, mask3;
   ImColor icl;
   int bl,br,bt,bb;
   Fnt *fn;
   Style *st;
   
   if (argc<2)
     {
	printf("Usage:\n");
	printf("\t%s file.eim\n",argv[0]);
	exit(0);
     }
   disp=XOpenDisplay(NULL);
   imd=ImlibInit(disp);
   fnd=FontlibInit(imd);
   sprintf(s,"%s:unselected",argv[1]);
   im1=ImlibLoadImage(imd,s,NULL);
   sprintf(s,"%s:selected",argv[1]);
   im2=ImlibLoadImage(imd,s,NULL);
   sprintf(s,"%s:clicked",argv[1]);
   im3=ImlibLoadImage(imd,s,NULL);
   ImlibGetImageTransparentColor(imd,im1,&icl);
   ImlibGetImageBorder(imd,im1,&bl,&br,&bt,&bb);
   printf("%i %i %i\n",icl.r,icl.g,icl.b);
   printf("%i %i %i %i\n",bl,br,bt,bb);
   win=XCreateSimpleWindow(disp,RootWindow(disp,DefaultScreen(disp)),0,0,
					   im1->rgb_width,im1->rgb_height,
					   0,0,0);
   ImlibRender(imd,im1,im1->rgb_width,im1->rgb_height);
   ImlibRender(imd,im2,im2->rgb_width,im2->rgb_height);
   ImlibRender(imd,im3,im3->rgb_width,im3->rgb_height);
   pmap1=ImlibMoveImageToPixmap(imd,im1);
   pmap2=ImlibMoveImageToPixmap(imd,im2);
   pmap3=ImlibMoveImageToPixmap(imd,im3);
   mask1=ImlibMoveMaskToPixmap(imd,im1);
   mask2=ImlibMoveMaskToPixmap(imd,im2);
   mask3=ImlibMoveMaskToPixmap(imd,im3);
   XSelectInput(disp,win,ButtonPressMask|ButtonReleaseMask|EnterWindowMask|LeaveWindowMask|StructureNotifyMask);
   XSetWindowBackgroundPixmap(disp,win,pmap1);
   if (mask1) XShapeCombineMask(disp,win,ShapeBounding,0,0,mask1,ShapeSet);
   XClearWindow(disp,win);
   st=setstyle();
   fn=FontlibLoadFont(fnd,"helvetica",0);
   XMapWindow(disp,win);
   XSync(disp,False);
   FontlibDrawText(fnd,win,fn,st,FNJUST_CENTER,
		   im1->border.left,im1->border.top,
		   im1->width-im1->border.left-im1->border.right,
		   im1->height-im1->border.top-im1->border.bottom,
		   argv[1]);
   for(;;)
     {
	XNextEvent(disp,&ev);
	switch (ev.type)
	  {
	   case ButtonPress:
	     printf("1\n");
	     XSetWindowBackgroundPixmap(disp,win,pmap3);
	     if (mask3) XShapeCombineMask(disp,win,ShapeBounding,0,0,mask3,ShapeSet);
	     XClearWindow(disp,win);
	     FontlibDrawText(fnd,win,fn,st,FNJUST_CENTER,
			     im1->border.left,im1->border.top,
			     im1->width-im1->border.left-im1->border.right,
			     im1->height-im1->border.top-im1->border.bottom,
			     argv[1]);
	     break;
	   case ButtonRelease:
	     printf("2\n");
	     XSetWindowBackgroundPixmap(disp,win,pmap2);
	     if (mask2) XShapeCombineMask(disp,win,ShapeBounding,0,0,mask2,ShapeSet);
	     XClearWindow(disp,win);
	     FontlibDrawText(fnd,win,fn,st,FNJUST_CENTER,
			     im1->border.left,im1->border.top,
			     im1->width-im1->border.left-im1->border.right,
			     im1->height-im1->border.top-im1->border.bottom,
			     argv[1]);
	     break;
	   case EnterNotify:
	     printf("3\n");
	     XSetWindowBackgroundPixmap(disp,win,pmap2);
	     if (mask2) XShapeCombineMask(disp,win,ShapeBounding,0,0,mask2,ShapeSet);
	     XClearWindow(disp,win);
	     FontlibDrawText(fnd,win,fn,st,FNJUST_CENTER,
			     im1->border.left,im1->border.top,
			     im1->width-im1->border.left-im1->border.right,
			     im1->height-im1->border.top-im1->border.bottom,
			     argv[1]);
	     break;
	   case LeaveNotify:
	     printf("4\n");
	     XSetWindowBackgroundPixmap(disp,win,pmap1);
	     if (mask1) XShapeCombineMask(disp,win,ShapeBounding,0,0,mask1,ShapeSet);
	     XClearWindow(disp,win);
	     FontlibDrawText(fnd,win,fn,st,FNJUST_CENTER,
			     im1->border.left,im1->border.top,
			     im1->width-im1->border.left-im1->border.right,
			     im1->height-im1->border.top-im1->border.bottom,
			     argv[1]);
	     break;
	   case ConfigureNotify:
	       {
		  int w,h;
		  int d;
		  Window r;
		  
		  printf("5\n");
		  XGetGeometry(disp,win,&r,&d,&d,&w,&h,&d,&d);
		  ImlibFreePixmap(imd,pmap1);
		  ImlibFreePixmap(imd,pmap2);
		  ImlibFreePixmap(imd,pmap3);
		  ImlibFreePixmap(imd,mask1);
		  ImlibFreePixmap(imd,mask2);
		  ImlibFreePixmap(imd,mask3);
		  ImlibRender(imd,im1,w,h);
		  ImlibRender(imd,im2,w,h);
		  ImlibRender(imd,im3,w,h);
		  pmap1=ImlibMoveImageToPixmap(imd,im1);
		  pmap2=ImlibMoveImageToPixmap(imd,im2);
		  pmap3=ImlibMoveImageToPixmap(imd,im3);
		  mask1=ImlibMoveMaskToPixmap(imd,im1);
		  mask2=ImlibMoveMaskToPixmap(imd,im2);
		  mask3=ImlibMoveMaskToPixmap(imd,im3);
		  XSetWindowBackgroundPixmap(disp,win,pmap1);
		  if (mask1) XShapeCombineMask(disp,win,ShapeBounding,0,0,mask1,ShapeSet);
		  XClearWindow(disp,win);
		  FontlibDrawText(fnd,win,fn,st,FNJUST_CENTER,
				  im1->border.left,im1->border.top,
				  im1->width-im1->border.left-im1->border.right,
				  im1->height-im1->border.top-im1->border.bottom,
				  argv[1]);
	       }
	     break;
	   default:
	     break;
	  }
	XSync(disp,False);
     }
}

